import lxml.etree
from Service import Service
from Action import Action
from Parameter import Parameter
import os
import commands

class ReplenishServices:

	PATH_TO_XML_OF_SERVICES="/etc/llx-services/global.xml"

	def replenish(self):
		self.array_services = {}
		
		#LDAP AND KERBEROS INSTALL
		if not (commands.getstatusoutput("dpkg -l | grep llxcfg-ldap-server")[0]):
					
			if not (commands.getstatusoutput("dpkg -l | grep llxcfg-krb5-server")[0]):
				self.array_services['LDAP'] = {'name':"LDAP",'script':"backup_ldap",'type':"script",'flags':[{'name':"cpkg_update",'priority':'50'}]}
		
		if (os.path.exists("/net/share")):
			self.array_services['NetShare'] = {'name':"NetShare",'path':["/net/share"],'type':"path"}
	
		if((os.path.exists("/net/home/")) and (os.path.exists("/net/groups") )):
			self.array_services['NetHome'] = {'name':'NetHome','path':["/net/groups","/net/home"],'type':"path"}
	
		if not (commands.getstatusoutput("dpkg -l | grep llxcfg-dhcpd")[0]):
			if (os.path.exists("/var/lib/llxcfg/config/dhcp/mac")):
				self.array_services['DHCP'] = {'name':"DHCP",'path':["/var/lib/llxcfg/config/dhcp/mac"],'type':"path"}
	
		return self.array_services
		
	
	"""
	def replenish(self):
		
		
		self.array_services = []
		self.array_services.append("moodle")
		return self.array_services
		
		self.array_services = []
		print ReplenishServices.PATH_TO_XML_OF_SERVICES
		self.document = lxml.etree.parse(ReplenishServices.PATH_TO_XML_OF_SERVICES)
		self.root = self.document.getroot()
		
		for node in self.root:
			for service in node:
				actions = []
				
				if service.tag=="name":
					nombre=service.text
					
				if service.tag=="action":
					
					action_name="Unknown"
					action_binary="Unknown"
					for action in service: 
		
						
						parameters = []
						
						if action.tag=="name":
							action_name=action.text
							
						if action.tag=="bin":
							action_binary=action.text
						if action.tag=="param":
							parameter = Parameter(action.get("fixed"),action.get("type"),action.text)
							parameters.append(parameter)
					
					action = Action(action_name,action_binary,parameters)
					actions.append(action)
						
			service = Service(nombre,actions)
			self.array_services.append(service)
			
			
		return self.array_services
	"""
