import pygtk
pygtk.require("2.0")
import gtk, gtk.glade
import commands
import threading
import os
import Replenish_services

HOME_DIRECTORY="/home/"
MAIL_DIRECTORY="thunderbird"
FIREFOX_DIRECTORY="firefox"
MOZILLA_DIRECTORY=".mozilla"
DESKTOP_DIRECTORY="Desktop"

class Transmigracion:

	
	
		gtk.gdk.threads_init()
	
		

		self.glade_main = gtk.glade.XML("lliurex-migration.glade")
		self.glade_import_step1 = gtk.glade.XML("lliurex-migration-import-step1.glade")
		self.glade_import_step2 = gtk.glade.XML("lliurex-migration-import-step2.glade")

		self.glade_main.signal_autoconnect(self)
		self.glade_import_step1.signal_autoconnect(self)
		self.glade_import_step2.signal_autoconnect(self)
	

		self.window_main = self.glade_main.get_widget("window_main")
		self.window_main.show_all()
		self.panel_main = self.glade_main.get_widget("fixed_main")
	
		"""
		Import Step1 WIDGETS 
		"""

		self.panel_import_step1 = self.glade_import_step1.get_widget("fixed_import_step1")
		self.panel_import_step1.unparent()

		"""
		GTKTreeView for Users
		"""
		self.liststore = gtk.ListStore(bool,str)
		self.tree_users = self.glade_import_step1.get_widget("treeview_users")
		self.tree_users.set_model(self.liststore)
		self.renderer1 = gtk.CellRendererToggle()
		self.renderer1.set_property('activatable', True)
		self.renderer1.connect( 'toggled', self.col1_toggled_cb )
		self.renderer2 = gtk.CellRendererText()
		self.column1 =  gtk.TreeViewColumn(" ", self.renderer1) 
		self.column1.set_resizable(True)
		self.column1.add_attribute(self.renderer1, 'active', 0)
		self.column2 =  gtk.TreeViewColumn(" ", self.renderer2)
		self.column2.set_resizable(True)
		self.column2.add_attribute(self.renderer2, 'text', 1)
	
		self.tree_users.append_column(self.column1)
		self.tree_users.append_column(self.column2)
	
		self.returnUsers = os.listdir(HOME_DIRECTORY)
	
		"""
		GTKTreeView for Custom Directories
		"""
		self.customlist = gtk.ListStore(str)
		self.tree_custom_list= self.glade_import_step1.get_widget("treeview_custom_directories")
		self.tree_custom_list.set_model(self.customlist)
		renderer_custom_list= gtk.CellRendererText()
		custom_column= gtk.TreeViewColumn(" ", renderer_custom_list)
		custom_column.add_attribute(renderer_custom_list,'text',0)
		self.tree_custom_list.append_column(custom_column)
	
	
		"""
		Now Replenish Users
		"""
		for users in self.returnUsers :
			if (not (users=="lost+found")):
				if (os.path.isdir(HOME_DIRECTORY+os.sep+users)):
					self.node = self.liststore.append([True, users]) 
	

		self.glade_import_step1.get_widget("cb_home_directories").set_active(True)

		
		"""
		STEP 2
		All Checkboxes in Server Configuration are marked by default
		the common  Next->Next->Next operation makes a backup of 
		all the important data.
		"""
		""" Import Step2 """
		self.panel_import_step2 = self.glade_import_step2.get_widget("fixed_import_step2")
		self.panel_import_step2.unparent()

		""" Additional conditions of Step2"""
		
		"""Net Users Toggled by Default"""
		self.glade_import_step2.get_widget("cb_keep_net_users").set_active(True)
		
		"""# Teachers"""
		self.glade_import_step2.get_widget("cb_teachers").set_active(True)
		self.glade_import_step2.get_widget("cb_teachers_keep_data").set_active(True)
		self.glade_import_step2.get_widget("cb_teachers_keep_config").set_active(True)
		
		"""# Students"""
		self.glade_import_step2.get_widget("cb_students").set_active(True)
		self.glade_import_step2.get_widget("cb_students_keep_data").set_active(True)
		self.glade_import_step2.get_widget("cb_students_keep_config").set_active(True)
		
		"""# Others"""
		self.glade_import_step2.get_widget("cb_others").set_active(True)
		self.glade_import_step2.get_widget("cb_others_keep_data").set_active(True)
		self.glade_import_step2.get_widget("cb_others_keep_config").set_active(True)
		
		"""# Server Data"""
		self.glade_import_step2.get_widget("cb_net_share").set_active(True)
		self.glade_import_step2.get_widget("cb_www_srv").set_active(True)
		
		
		"""# Llxcfg"""
		self.glade_import_step2.get_widget("cb_llxvars").set_active(True)
		
	
	def col1_toggled_cb( self, cell, path ):
		"""
		Sets the toggled state on the toggle button to true or false.
		"""
		iter = self.liststore.get_iter(path)
		value = self.liststore.get_value(iter,0)
		self.liststore.set_value(iter,0,not value)
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()
	
		return


	def go_to_start(self,widget_to_remove):
		"""
		Go to the Main Window
		"""
		self.window_main.remove(widget_to_remove)
		self.window_main.add(self.panel_main)    

	def change_panel(self,widget_to_remove,widget_to_open):
		"""
		Change the Panel that is showed at this moment
		"""
		self.window_main.remove(widget_to_remove)
		self.window_main.add(widget_to_open)   

	def on_assistant_delete_event(self, widget, event):
		gtk.main_quit()

	"""# FORWARD AND BACK BUTTONS"""
	def on_bt_inicio_importar_clicked(self,widget):
		self.change_panel(self.panel_main,self.panel_import_step1)

	def on_bt_import_step1_continue_clicked(self,widget):
		self.change_panel(self.panel_import_step1,self.panel_import_step2)

	def on_bt_import_step2_back_clicked(self,widget):
		self.change_panel(self.panel_import_step2,self.panel_import_step1)

	"""# CANCEL BUTTONS    """
	def on_bt_import_step1_cancel_clicked(self,widget):
		self.go_to_start(self.panel_import_step1)

	def on_bt_import_step2_cancel_clicked(self,widget):
		self.go_to_start(self.panel_import_step2)

	def on_bt_inicio_exportar_clicked(self,widget):
		gtk.main_quit()

	def on_bt_exit_clicked(self,widget):
		gtk.main_quit()

	"""
	# LOCAL USERS
	"""

	def on_bt_check_size_clicked(self,widget):
		print "Clicked and Build the Paths"
		self.build_personal_paths()

	"""# TOGGLE BUTTONS"""
	def on_cb_home_directories_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

		if (self.glade_import_step1.get_widget("cb_home_directories").get_active()):
			self.glade_import_step1.get_widget("cb_mail").set_sensitive(False)
			self.glade_import_step1.get_widget("cb_bookmarks").set_sensitive(False)
			self.glade_import_step1.get_widget("cb_desktop_directories").set_sensitive(False)

		else:
			self.glade_import_step1.get_widget("cb_mail").set_sensitive(True)
			self.glade_import_step1.get_widget("cb_bookmarks").set_sensitive(True)
			self.glade_import_step1.get_widget("cb_desktop_directories").set_sensitive(True)

	def on_cb_mail_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()
	
	def on_cb_desktop_directories_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

	def on_cb_bookmarks_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

	def on_bt_add_custom_directory_clicked(self,widget):
		aux_path=self.glade_import_step1.get_widget("filechooserbutton_personal").get_filename()
		self.customlist.append([aux_path])
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

	def on_bt_del_custom_directory_clicked(self,widget):
		model,iter= self.tree_custom_list.get_selection().get_selected()
		if (not(iter == None)):
			model.remove(iter)
			self.scan_thread=threading.Thread(target=self.compute_personal_paths)
			self.scan_thread.start()

	"""
	 NET USERS
	"""
	def on_cb_keep_net_users_toggled(self,widget):
		if (self.glade_import_step2.get_widget("cb_keep_net_users").get_active()):
			# Teachers
			self.glade_import_step2.get_widget("cb_teachers").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_teachers_keep_data").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_teachers_keep_config").set_sensitive(True)
			# Students
			self.glade_import_step2.get_widget("cb_students").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_students_keep_data").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_students_keep_config").set_sensitive(True)
			# Others
			self.glade_import_step2.get_widget("cb_others").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_others_keep_data").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_others_keep_config").set_sensitive(True)
			
		else:
			# Teachers
			self.glade_import_step2.get_widget("cb_teachers").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_teachers_keep_data").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_teachers_keep_config").set_sensitive(False)
			# Students
			self.glade_import_step2.get_widget("cb_students").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_students_keep_data").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_students_keep_config").set_sensitive(False)
			# Others
			self.glade_import_step2.get_widget("cb_others").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_others_keep_data").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_others_keep_config").set_sensitive(False)
			
	def on_cb_teachers_toggled(self,widget):
		if (self.glade_import_step2.get_widget("cb_teachers").get_active()):
			self.glade_import_step2.get_widget("cb_teachers_keep_data").set_sensitive(True)
			self.glade_import_step2.get_widget("cb_teachers_keep_config").set_sensitive(True)
		else:
			self.glade_import_step2.get_widget("cb_teachers_keep_data").set_sensitive(False)
			self.glade_import_step2.get_widget("cb_teachers_keep_config").set_sensitive(False)
	
	def on_cb_students_toggled(self,widget):
		value = self.glade_import_step2.get_widget("cb_students").get_active()
		self.glade_import_step2.get_widget("cb_students_keep_data").set_sensitive(value)
		self.glade_import_step2.get_widget("cb_students_keep_config").set_sensitive(value)
	
	def on_cb_others_toggled(self,widget):
		value = self.glade_import_step2.get_widget("cb_others").get_active()
		self.glade_import_step2.get_widget("cb_others_keep_data").set_sensitive(value)
		self.glade_import_step2.get_widget("cb_others_keep_config").set_sensitive(value)
	


	def compute_personal_paths(self):
		"""
		Build and 
		"""
		# Init some values
		self.list_of_personal_directories = list()
		self.list_of_sizes = list()
		self.total_size=0
	
	
		gtk.gdk.threads_enter()
	
	
		#If $HOME directories is active:
		if (self.glade_import_step1.get_widget("cb_home_directories").get_active()):
			
			for usernode in self.liststore:
				if usernode[0] :
					aux_size =  commands.getoutput(('du -s '+ HOME_DIRECTORY +usernode[1])).split('\t')[0]
					self.total_size = self.total_size + int(aux_size)
		

		else:
			# If $MAIL directories is active
			if(self.glade_import_step1.get_widget("cb_mail").get_active()):

				for usernode in self.liststore:
					if usernode[0] :
						if os.path.exists(HOME_DIRECTORY +usernode[1]+os.sep+MOZILLA_DIRECTORY+os.sep+MAIL_DIRECTORY+os.sep):
							aux_size =  commands.getoutput(('du -s '+ HOME_DIRECTORY +usernode[1]+os.sep+MOZILLA_DIRECTORY+os.sep+MAIL_DIRECTORY+os.sep)).split('\t')[0]
							self.total_size = self.total_size + int(aux_size)

			if(self.glade_import_step1.get_widget("cb_bookmarks").get_active()):
				for usernode in self.liststore:
					if usernode[0] :
						if os.path.exists(HOME_DIRECTORY +usernode[1]+os.sep+MOZILLA_DIRECTORY+os.sep+FIREFOX_DIRECTORY+os.sep):
							aux_size =  commands.getoutput(('du -s '+ HOME_DIRECTORY +usernode[1]+os.sep+MOZILLA_DIRECTORY+os.sep+FIREFOX_DIRECTORY+os.sep)).split('\t')[0]
							self.total_size = self.total_size + int(aux_size)
						
			if(self.glade_import_step1.get_widget("cb_desktop_directories").get_active()):
				for usernode in self.liststore:
					if usernode[0] :
						if os.path.exists(HOME_DIRECTORY +usernode[1]+os.sep+DESKTOP_DIRECTORY+os.sep):
							aux_size =  commands.getoutput(('du -s '+ HOME_DIRECTORY +usernode[1]+os.sep+DESKTOP_DIRECTORY+os.sep)).split('\t')[0]
							self.total_size = self.total_size + int(aux_size)
	
		# Custom directories
		for custom_dir in self.customlist:
			if os.path.exists(custom_dir[0]):
				aux_size =  commands.getoutput(('du -s '+custom_dir[0])).split('\t')[0]
				self.total_size = self.total_size + int(aux_size)

		self.glade_import_step1.get_widget("label_size").set_text(self.bytes_to_human_readable_sizes(self.total_size))
	
		gtk.gdk.threads_leave()

	def bytes_to_human_readable_sizes(self,quantity):
		result="0 MB"
	
		megas=quantity/1024
		gigas=megas/1024
		teras=gigas/1024
	
		if (teras >0):
			teras = float(gigas/1024.0)
			result= "%.2f TB"%teras
		else :
			if (gigas > 0): 
				gigas = float(megas/1024.0)
				result="%.2f GB"%gigas
			else :
				if(megas > 0):
					megas = float(quantity/1024.0)
					result ="%.2f MB" %megas
	
		return " "+(result)
	

if __name__ == "__main__":
	try:
		a = Transmigracion()
		gtk.main()
	except KeyboardInterrupt:
		pass
