import pygtk
pygtk.require("2.0")
import gtk, gtk.glade
import commands
import threading
import subprocess
import os
from pwd import getpwnam
from lxml import etree
import datetime 
import tempfile
import shutil
import ReplenishServices
import Restore
import glob
import fileinput
import string
import sys
import gettext
import locale
from gtk.glade import bindtextdomain, textdomain 

HOME_DIRECTORY="/home/"
MAIL_DIRECTORY="thunderbird"
FIREFOX_DIRECTORY="firefox"
MOZILLA_DIRECTORY=".mozilla"
DESKTOP_DIRECTORY="Desktop"
BACKUPS_VERSION=0.1
LLXCFG_VARS_PATH="/etc/llxcfg/vars/"
LLXCFG_CONFILES_PATH="/etc/llxcfg/config/"
PATH_TO_SCRIPTS="/usr/share/lliurex-vault/scripts/"
PATH_TO_INFO_ES="/usr/share/lliurex-vault/info/es/"
PATH_TO_INFO_QCV="/usr/share/lliurex-vault/info/qcv/"
PATH_TO_BINARY_INCLUDED="/usr/share/lliurex-vault/scripts/lliurex-vault-run-restore"
VAULT_SCRIPTS="vault-scripts.d"
DEBUG_ACTIVE=False
APP="lliurex-vault"
DEBUG_PROGRESS=True

locale.textdomain(APP)
gettext.textdomain(APP)
bindtextdomain(APP) 
_ = gettext.gettext



class Transmigracion:

	
	def  __init__(self):
		gtk.gdk.threads_init()
	
	
		self.restore = Restore.Restore(self)

		self.glade_main = gtk.glade.XML("/usr/share/python-support/lliurex-vault/lliurex-migration.glade",domain="lliurex-vault")
		self.glade_import_step1 = gtk.glade.XML("/usr/share/python-support/lliurex-vault/lliurex-migration-import-step1.glade",domain="lliurex-vault")
		self.glade_import_step2 = gtk.glade.XML("/usr/share/python-support/lliurex-vault/lliurex-migration-import-step2.glade",domain="lliurex-vault")
		

		self.glade_main.signal_autoconnect(self)
		self.glade_import_step1.signal_autoconnect(self)
		self.glade_import_step2.signal_autoconnect(self)
	

		self.window_main = self.glade_main.get_widget("window_main")
		self.window_main.show_all()
		self.window_main.connect("destroy", gtk.main_quit)
		self.panel_main = self.glade_main.get_widget("fixed_main")
	
		"""
		Import Step1 WIDGETS 
		"""

		self.panel_import_step1 = self.glade_import_step1.get_widget("fixed_import_step1")
		self.panel_import_step1.unparent()

		"""
		GTKTreeView for Users
		"""
		# Created liststore with "checked, user, home" values
		self.liststore = gtk.ListStore(bool,str,str)
		self.tree_users = self.glade_import_step1.get_widget("treeview_users")
		self.tree_users.set_model(self.liststore)
		self.renderer1 = gtk.CellRendererToggle()
		self.renderer1.set_property('activatable', True)
		self.renderer1.connect( 'toggled', self.col1_toggled_cb )
		self.renderer2 = gtk.CellRendererText()
		self.column1 =  gtk.TreeViewColumn(" ", self.renderer1) 
		self.column1.set_resizable(True)
		self.column1.add_attribute(self.renderer1, 'active', 0)
		self.column2 =  gtk.TreeViewColumn(" ", self.renderer2)
		self.column2.set_resizable(True)
		self.column2.add_attribute(self.renderer2, 'text', 1)
	
		self.tree_users.append_column(self.column1)
		self.tree_users.append_column(self.column2)
	
		# Get the REAL system users and the real system home directories
		
		self.returnUsers=list()
		
		file_etc_passwd=open("/etc/passwd")
		for line in file_etc_passwd.readlines():
			rec = string.splitfields(line, ':')
			uid=int(rec[2])
			if ( uid > 999 or uid ==0 ):
				if (os.path.isdir(rec[5])):     
					self.dprint (rec[0]+" "+rec[5])
					self.returnUsers.append([rec[0],rec[5]])
					
		"""
		GTKTreeView for Custom Directories
		"""
		self.customlist = gtk.ListStore(str)
		self.tree_custom_list= self.glade_import_step1.get_widget("treeview_custom_directories")
		self.tree_custom_list.set_model(self.customlist)
		renderer_custom_list= gtk.CellRendererText()
		custom_column= gtk.TreeViewColumn(" ", renderer_custom_list)
		custom_column.add_attribute(renderer_custom_list,'text',0)
		self.tree_custom_list.append_column(custom_column)
	
	
		"""
		Now Replenish Users
		"""
		for users in self.returnUsers :

			self.node = self.liststore.append([True, users[0], users[1]]) 
	

		self.glade_import_step1.get_widget("cb_home_directories").set_active(True)

		
		"""
		STEP 2
		All Checkboxes in Server Configuration are marked by default
		the common  Next->Next->Next operation makes a backup of 
		all the important data.
		"""
		""" Import Step2 """
		self.panel_import_step2 = self.glade_import_step2.get_widget("fixed_import_step2")
		self.panel_import_step2.unparent()
	
		self.fixed_panel_final = self.glade_import_step2.get_widget("fixed_panel_final")
		self.fixed_panel_final.unparent()
		

		""" Additional conditions of Step2"""
		
		
		"""# Llxcfg"""
		self.glade_import_step2.get_widget("cb_llxvars").set_active(True)
		
		
		
		"""
		LIST OF SERVICES (POWERED BY ReplenishServices)
		"""
		self.rservices=ReplenishServices.ReplenishServices().replenish()
		self.listservices = gtk.ListStore(bool,str,str)
		if not self.rservices == None:
			for name in self.rservices.keys():
				self.listservices.append([True,self.rservices[name]['name'],name])
				
			self.treeservices = self.glade_import_step2.get_widget("treeview_services")
			self.treeservices.set_model(self.listservices)
			
			self.rendererServices1 = gtk.CellRendererToggle()
			self.rendererServices1.set_property('activatable', True)
			self.rendererServices1.connect( 'toggled', self.services_toggled )
			self.rendererServices2 = gtk.CellRendererText()
			
			self.columnServices1 =  gtk.TreeViewColumn(" ", self.rendererServices1) 
			self.columnServices1.set_resizable(True)
			self.columnServices1.add_attribute(self.rendererServices1, 'active', 0)
			self.columnServices2 =  gtk.TreeViewColumn(" ", self.rendererServices2)
			self.columnServices2.set_resizable(True)
			self.columnServices2.add_attribute(self.rendererServices2, 'text', 1)
		
			self.treeservices.append_column(self.columnServices1)
			self.treeservices.append_column(self.columnServices2)
	
	
	def on_button_about_clicked(self,widget):
		
		self.window_about=self.glade_main.get_widget("aboutdialog")
		window_show_status= self.window_about.run()
		
		self.window_about.hide()
	
	
	def services_toggled(self,cell,path):
		self.dprint ("toggled")
		iter = self.listservices.get_iter(path)
		value = self.listservices.get_value(iter,0)
		self.listservices.set_value(iter,0,not value)

	def col1_toggled_cb( self, cell, path ):
		iter = self.liststore.get_iter(path)
		value = self.liststore.get_value(iter,0)
		self.liststore.set_value(iter,0,not value)
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()



	def go_to_start(self,widget_to_remove):
		"""
		Go to the Main Window
		"""
		self.window_main.remove(widget_to_remove)
		self.window_main.add(self.panel_main)    

	def change_panel(self,widget_to_remove,widget_to_open):
		"""
		Change the Panel that is showed at this moment
		"""
		self.window_main.remove(widget_to_remove)
		self.window_main.add(widget_to_open)   

	def on_assistant_delete_event(self, widget, event):
		gtk.main_quit()

	"""# FORWARD AND BACK BUTTONS"""
	def on_bt_inicio_importar_clicked(self,widget):
		self.change_panel(self.panel_main,self.panel_import_step1)

	def on_bt_import_step1_continue_clicked(self,widget):
		self.change_panel(self.panel_import_step1,self.panel_import_step2)

	def on_bt_import_step2_back_clicked(self,widget):
		self.change_panel(self.panel_import_step2,self.panel_import_step1)

	"""# CANCEL BUTTONS    """
	def on_bt_import_step1_cancel_clicked(self,widget):
		self.go_to_start(self.panel_import_step1)

	def on_bt_import_step2_cancel_clicked(self,widget):
		self.go_to_start(self.panel_import_step2)

	def on_bt_inicio_exportar_clicked(self,widget):
		self.window_main.remove(self.panel_main)
		self.restore.show()

	def on_bt_exit_clicked(self,widget):
		gtk.main_quit()

	"""
	# LOCAL USERS
	"""

	def on_bt_check_size_clicked(self,widget):
		dprint ("Clicked and Build the Paths")
		self.build_personal_paths()

	"""# TOGGLE BUTTONS"""
	def on_cb_home_directories_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

		if (self.glade_import_step1.get_widget("cb_home_directories").get_active()):
			self.glade_import_step1.get_widget("cb_mail").set_sensitive(False)
			self.glade_import_step1.get_widget("cb_bookmarks").set_sensitive(False)
			self.glade_import_step1.get_widget("cb_desktop_directories").set_sensitive(False)

		else:
			self.glade_import_step1.get_widget("cb_mail").set_sensitive(True)
			self.glade_import_step1.get_widget("cb_bookmarks").set_sensitive(True)
			self.glade_import_step1.get_widget("cb_desktop_directories").set_sensitive(True)

	def on_cb_mail_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()
	
	def on_cb_desktop_directories_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

	def on_cb_bookmarks_toggled(self,widget):
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

	def on_bt_add_custom_directory_clicked(self,widget):
		aux_path=self.glade_import_step1.get_widget("filechooserbutton_personal").get_filename()
		self.customlist.append([aux_path])
		self.scan_thread=threading.Thread(target=self.compute_personal_paths)
		self.scan_thread.start()

	def on_bt_del_custom_directory_clicked(self,widget):
		model,iter= self.tree_custom_list.get_selection().get_selected()
		if (not(iter == None)):
			model.remove(iter)
			self.scan_thread=threading.Thread(target=self.compute_personal_paths)
			self.scan_thread.start()


	def on_button_finished_accept_clicked(self,widget):
		
		self.WindowFinished.hide()
	"""
	 NET USERS
	"""

	def on_button_finished_accept_clicked(self,widget):
		self.window_finished.hide()
		makeBackup_thread=threading.Thread(target=self.create_info_file)
		makeBackup_thread.start()
		

	def on_button_finished_cancel_clicked(self,widget):

		self.window_finished.hide()

	def on_bt_import_step2_continue_clicked(self,widget):
		
		self.window_finished = self.glade_import_step2.get_widget("window_finished")
		self.label_destiny = self.glade_import_step2.get_widget("label_destiny")
		self.label_destiny.set_label(self.glade_import_step2.get_widget("fcb_destiny").get_filename())
		self.window_finished.show()
		
	def on_button_final_exit_clicked(self,widget):
		gtk.main_quit()

	def dprint(self, text):
		if DEBUG_ACTIVE :
			print text


	def create_info_file(self):
		
		# Create Tempdirectory
		self.dprint("DEBUG is ACTIVE")
		self.dprint("DEBUG: create temporal directory")
		self.WindowProgressBar=self.glade_import_step2.get_widget("window-progress")
		self.ProgressBar=self.glade_import_step2.get_widget("progressbar")
		self.dprint("DEBUG: progressbar show?")
		# Mostramos la barra de progreso 
		# y establecemos el progreso al 10% 
		if DEBUG_PROGRESS :
			self.WindowProgressBar.show()
			self.dprint("DEBUG: progressbar show!")
			gtk.gdk.threads_enter()
			self.ProgressBar.set_fraction(0.1)
			gtk.gdk.threads_leave()
		
		# Obtenemos directorio destino de la copia a partir del widget
		self.tmp_backup_dir=self.glade_import_step2.get_widget("fcb_destiny").get_filename()
		shutil.copy(PATH_TO_BINARY_INCLUDED,self.tmp_backup_dir)
		self.dprint("DEBUG: path is : "+self.tmp_backup_dir+os.sep+"lliurex-vault-data")
		aux_path_of_exists=self.tmp_backup_dir+os.sep+"lliurex-vault-data"
		# Si en ese directorio ya existe una copia de seguridad en ese directorio
		# se borra y se crea una nueva.
		if os.path.exists(aux_path_of_exists):
			self.dprint("DEBUG: directory exists...cleaning environment")
			shutil.rmtree(self.tmp_backup_dir+os.sep+"lliurex-vault-data")
		os.mkdir(self.tmp_backup_dir+os.sep+"lliurex-vault-data")
		self.dprint("DEBUG: create temporal directory on "+self.tmp_backup_dir+ " ")
		self.backup_dir=self.tmp_backup_dir+os.sep+"lliurex-vault-data"
		
		
		"""
		THE PERSONALS BACKUPS
		"""
		
		self.dprint("DEBUG: Doing Personal Backups")
		for user in self.liststore:
			if user[0]:
				
				self.dprint("DEBUG: For user in User list")
				name=user[1]
				
				# First create the backup directory
				os.mkdir(self.backup_dir+os.sep+user[1])
				
				# Creamos el directorio de la carpeta personal 
				self.dprint("DEBUG: created directory for "+ user[1] )
				personal_vault_directory=self.backup_dir+os.sep+user[1]+os.sep+VAULT_SCRIPTS+os.sep
				os.mkdir(personal_vault_directory)
				
				# Preparamos el directorio objetivo de la copia
				self.dprint("DEBUG: created directory for " + user[1] + "on " + personal_vault_directory)
				cmd_home_backup="lliurex-vault-copy --backup "+personal_vault_directory
				cmd_home_backup_extended="lliurex-vault-owner --backup "+personal_vault_directory
				backup_personal_path=self.backup_dir+os.sep+name+os.sep
				personal_path_home=self.backup_dir+os.sep+user[1]
				backup_personal_path_home=user[2]+os.sep
				
				self.dprint("DEBUG: target directory is " + backup_personal_path_home)
				
				# Si se trata de TODO el directorio personal se copia entero
				if (self.glade_import_step1.get_widget("cb_home_directories").get_active()):
					
					self.dprint("DEBUG: cb_home_directories is active")
					
					# Copy the info files
					shutil.copy(PATH_TO_INFO_ES+os.sep+"personal-home.es",backup_personal_path+"personal-home.es")
					shutil.copy(PATH_TO_INFO_QCV+os.sep+"personal-home.qcv",backup_personal_path+"personal-home.qcv")
				
					# Backup personal homes
					cmd=cmd_home_backup+"50-restore-data-homes"+" lliurex-vault-home "+personal_path_home+" "+backup_personal_path_home
					cmd_2=cmd_home_backup_extended+"80-restore-owner-homes"+" lliurex-vault-home "+personal_path_home+" "+backup_personal_path_home
					commands.getstatusoutput(cmd)
					commands.getstatusoutput(cmd_2)

				else :
					# Thunderbird
					if (self.glade_import_step1.get_widget("cb_mail").get_active()):
						
						self.dprint("DEBUG: cb_mail is active")
						
						# Copy the info files
						shutil.copy(PATH_TO_INFO_ES+os.sep+"mail.es",backup_personal_path+"mail.es")
						shutil.copy(PATH_TO_INFO_QCV+os.sep+"mail.qcv",backup_personal_path+"mail.qcv")
						
						# Backup mail
						cmd=cmd_home_backup+"60-restore-mail"+" lliurex-vault-mail "+personal_path_home+" "+backup_personal_path_home+MOZILLA_DIRECTORY+os.sep+MAIL_DIRECTORY
						cmd_2=cmd_home_backup_extended+"61-restore-owner-mail"+" lliurex-vault-mail "+personal_path_home+" "+backup_personal_path_home+MOZILLA_DIRECTORY+os.sep+MAIL_DIRECTORY
						commands.getstatusoutput(cmd)
						commands.getstatusoutput(cmd_2)
						
					# Bookmarks del firefox	
					if (self.glade_import_step1.get_widget("cb_bookmarks").get_active()):
						
						self.dprint("DEBUG: cb_bookmarks is active")
						
						# Copy the info files
						shutil.copy(PATH_TO_INFO_ES+os.sep+"mozilla.es",backup_personal_path+"mozilla.es")
						shutil.copy(PATH_TO_INFO_QCV+os.sep+"mozilla.qcv",backup_personal_path+"mozilla.qcv")

						# Backup firefox
						cmd=cmd_home_backup+"65-restore-firefox"+" lliurex-vault-firefox "+personal_path_home+" "+backup_personal_path_home+MOZILLA_DIRECTORY+os.sep+FIREFOX_DIRECTORY
						cmd_2=cmd_home_backup_extended+"66-restore-owner-firefox"+" lliurex-vault-firefox "+personal_path_home+" "+backup_personal_path_home+MOZILLA_DIRECTORY+os.sep+FIREFOX_DIRECTORY
						commands.getstatusoutput(cmd)
						commands.getstatusoutput(cmd_2)
					# Carpeta del escritorio
					
					if (self.glade_import_step1.get_widget("cb_desktop_directories").get_active()):
						
						self.dprint( "DEBUG: cb_desktop_directories is active")
						
						# Copy the info files
						shutil.copy(PATH_TO_INFO_ES+os.sep+"desktop.es",backup_personal_path+"desktop.es")
						shutil.copy(PATH_TO_INFO_QCV+os.sep+"desktop.qcv",backup_personal_path+"desktop.qcv")
						
						# Backup Desktop directories
						cmd=cmd_home_backup+"70-restore-desktop"+" lliurex-vault-desktop "+personal_path_home+" "+backup_personal_path_home+DESKTOP_DIRECTORY
						cmd_2=cmd_home_backup_extended+"71-restore-owner-desktop"+" lliurex-vault-desktop "+personal_path_home+" "+backup_personal_path_home+DESKTOP_DIRECTORY
						commands.getstatusoutput(cmd)
						commands.getstatusoutput(cmd_2)
				
				# Generamos los ficheros de informacion para la restauracion posterior.
				self.dprint("DEBUG: LOCAL_USER variables will be changed")
				# Substitution of LOCAL_USER Variable inside info files
				self.general_substitution_info_files(self.backup_dir+os.sep+name+os.sep+"*.es","__LOCAL_USER__",name)
				self.general_substitution_info_files(self.backup_dir+os.sep+name+os.sep+"*.qcv","__LOCAL_USER__",name)
						
				# Now We must extract the uid for the User to restore it in 
				# the future
				try:
					uid=str(getpwnam(user[1])[2])
				except KeyError:
					pass

			"""Fin del IF"""
		"""Fin del FOR"""
		
		# Establecemos el porcentaje al 40%
		if DEBUG_PROGRESS :
			gtk.gdk.threads_enter()
			self.ProgressBar.set_fraction(0.4)
			gtk.gdk.threads_leave()
		
		# Comprobamos la lista de directorios adicionales
		self.dprint("DEBUG: Directories added?")
		if (len(self.customlist) > 0):
		
			item = etree.Element("item")
			name = etree.Element("name")
			paths = etree.Element("paths")
			name.text="Custom Directories"
		
			self.dprint("Creating directory on backup for these directories")
			os.mkdir(self.backup_dir+os.sep+"custom-dirs")
			custom_list_vault_directory=self.backup_dir+os.sep+"custom-dirs"+os.sep+VAULT_SCRIPTS+os.sep
			os.mkdir(custom_list_vault_directory)
			
			aux_dir=""
			# Recorremos la lista
			for directory in self.customlist:
				aux_dir=aux_dir+directory[0]+" " 
				self.dprint("DEBUG: Added directory "+directory[0]+" to the custom list")
			cmd  = "lliurex-vault-copy --backup "+custom_list_vault_directory+"50-restore-custom-directories-data"+" lliurex-vault-custom-dirs "+self.backup_dir+os.sep+"custom-dirs"+os.sep+" "+aux_dir
			commands.getstatusoutput(cmd)
			cmd  = "lliurex-vault-owner --backup "+custom_list_vault_directory+"50-restore-custom-directories-data"+" lliurex-vault-custom-dirs "+self.backup_dir+os.sep+"custom-dirs"+os.sep+" "+aux_dir
			commands.getstatusoutput(cmd)
			
			# ES INFO - > Generamos los ficheros de informacion para 
			self.dprint("DEBUG: Fixed ES INFO")
			origin=PATH_TO_INFO_ES+os.sep+"custom_directories.es"
			destiny=self.backup_dir+os.sep+"custom-dirs"+os.sep+"custom_directories.es"
			shutil.copy(origin,destiny)
			
			# QCV INFO - > Generamos los ficheros de informacion para  qcv
			self.dprint("DEBUG: Fixed QCV INFO")
			origin= PATH_TO_INFO_QCV+os.sep+"custom_directories.qcv"
			destiny=self.backup_dir+os.sep+"custom-dirs"+os.sep+"custom_directories.qcv"
			shutil.copy(origin,destiny)
			
		
			#/FOR
	
			
		#/IF of len (customlist)
		
		# Establecemos el porcentaje a 50%
		if DEBUG_PROGRESS :
			gtk.gdk.threads_enter()
			self.ProgressBar.set_fraction(0.5)
			gtk.gdk.threads_leave()
		
		
		# Trabajamos ahora con los servicios	
		
		iter=self.listservices.get_iter_first()
		if not iter == None:
			while True:
				check=self.listservices.get_value(iter,0)
				name=self.listservices.get_value(iter,1)
				id_name = self.listservices.get_value(iter,2)
				option = self.rservices[id_name]['type']
				flags = []
				if option == 'path':
					cmd = ' '.join(self.rservices[id_name]['path'])
				elif option == 'script':
					cmd = self.rservices[id_name]['script']
				if self.rservices[id_name].has_key('flags'):
					flags = self.rservices[id_name]['flags']
				
				# Esta parte es un poco oscura, pero la idea es que los servicios proporcionan
				# ellos mismos un binario capaz de realizar la copia de seguridad de cada uno
				# de ellos.
				# Para esto se utilizan unos parametros tales como path y script 
				# - > Si se trata de un path entonces basta con copiar el path en la copia de seguridad
				# - > Si se trata de un script entonces se ejecuta el script en vez de guardar las carpetas.
				#      este script ha de ser capaz de guardar los resultados en el lugar indicado como parametro
				#      y ademas generar un script "restaurador".
				
				if check:
					
					os.mkdir(self.backup_dir+os.sep+name)
					services_vault_directory=self.backup_dir+os.sep+name+os.sep+VAULT_SCRIPTS+os.sep
					os.mkdir(services_vault_directory)
					
					shutil.copy(PATH_TO_INFO_ES+os.sep+name+".es",self.backup_dir+os.sep+name+os.sep+name+".es")
					shutil.copy(PATH_TO_INFO_QCV+os.sep+name+".qcv",self.backup_dir+os.sep+name+os.sep+name+".qcv")
					
					#CMD Custom by service
					if (option == "path"): 
						aux_cmd = "lliurex-vault-copy --backup " +services_vault_directory+ "50-restore-service"+name+ " lliurex-vault-services "+self.backup_dir+os.sep+name+os.sep+" "+cmd 
						commands.getstatusoutput(aux_cmd)
						
					if (option == "script"): 
						aux_cmd = PATH_TO_SCRIPTS+cmd + " --backup "+self.backup_dir+os.sep+name+os.sep
						
						commands.getstatusoutput(aux_cmd)
						shutil.copy(PATH_TO_SCRIPTS+cmd,services_vault_directory+os.sep+cmd)
					for flag in flags:
						shutil.copy(PATH_TO_SCRIPTS+flag['name'],services_vault_directory+os.sep+flag['priority']+flag['name'])
				
				iter=self.listservices.iter_next(iter)
				if iter==None:
					break
		
		# Si debemos copiar las variables de LliureX
		
		if(self.glade_import_step2.get_widget("cb_llxvars").get_active()):
			self.dprint("DEBUG: cb_llxvars is active")
			os.mkdir(self.backup_dir+os.sep+"cb_llxvars")
			vars_vault_directory=self.backup_dir+os.sep+"cb_llxvars"+os.sep+VAULT_SCRIPTS+os.sep
			os.mkdir(vars_vault_directory)
			
			path_to_vars=os.path.abspath(LLXCFG_VARS_PATH)
	
			if os.path.islink(os.path.abspath(LLXCFG_VARS_PATH)) :
				path_to_vars=os.readlink(os.path.abspath(LLXCFG_VARS_PATH))
			
			shutil.copy(PATH_TO_INFO_ES+os.sep+"vars.es",self.backup_dir+os.sep+"cb_llxvars"+os.sep+"vars.es")
			shutil.copy(PATH_TO_INFO_QCV+os.sep+"vars.qcv",self.backup_dir+os.sep+"cb_llxvars"+os.sep+"vars.qcv")
			
			cmd="lliurex-vault-copy --backup "+vars_vault_directory+"50-llxvars-restore-data"+" lliurex-vault-vars "+self.backup_dir+os.sep+"cb_llxvars"+os.sep+" "+path_to_vars
			commands.getstatusoutput(cmd)
			cmd="lliurex-vault-owner --backup "+vars_vault_directory+"80-llxvars-restore-owner"+" lliurex-vault-vars "+self.backup_dir+os.sep+"cb_llxvars"+os.sep+" "+path_to_vars
			commands.getstatusoutput(cmd)

			shutil.copy(PATH_TO_SCRIPTS+"trigger_cpkg",vars_vault_directory+'99-trigger_cpkg')

			#Confiles
			self.dprint( "DEBUG: cb_llxconfiles is active")
			os.mkdir(self.backup_dir+os.sep+"cb_llxconfiles")
			confiles_vault_directory=self.backup_dir+os.sep+"cb_llxconfiles"+os.sep+VAULT_SCRIPTS+os.sep
			os.mkdir(confiles_vault_directory)
			
			# ES Info files
			self.dprint("DEBUG: Generating ES info files")
			origin=PATH_TO_INFO_ES+os.sep+"confiles.es"
			destiny=self.backup_dir+os.sep+"cb_llxconfiles"+os.sep+"confiles.es"
			shutil.copy(origin,destiny)
			
			# QCV info files
			self.dprint("DEBUG: Generating QCV info files")
			origin=PATH_TO_INFO_QCV+os.sep+"confiles.qcv"
			destiny=self.backup_dir+os.sep+"cb_llxconfiles"+os.sep+"confiles.qcv"
			shutil.copy(origin,destiny)
			
			path_to_confiles=os.path.abspath(LLXCFG_CONFILES_PATH)
	
			if os.path.islink(os.path.abspath(LLXCFG_CONFILES_PATH)) :
				path_to_confiles=os.readlink(os.path.abspath(LLXCFG_CONFILES_PATH))
				
			self.dprint("DEBUG: Copying  confiles vault directory")
			cmd="lliurex-vault-copy --backup "+confiles_vault_directory+"50-llxconfiles-restore-data"+" lliurex-vault-confiles "+self.backup_dir+os.sep+"cb_llxconfiles"+os.sep+" "+path_to_confiles
			commands.getstatusoutput(cmd)
			cmd="lliurex-vault-owner --backup "+confiles_vault_directory+"80-llxconfiles-restore-owner"+" lliurex-vault-confiles "+self.backup_dir+os.sep+"cb_llxconfiles"+os.sep+" "+path_to_confiles
			commands.getstatusoutput(cmd)
			
			
			
		if DEBUG_PROGRESS :
			gtk.gdk.threads_enter()
			self.ProgressBar.set_fraction(0.9)
			gtk.gdk.threads_leave()
			self.WindowProgressBar.hide()
		
		
		
		self.change_panel(self.panel_import_step2,self.fixed_panel_final)
		
		
		
		
		

	def compute_personal_paths(self):
		"""
		Build and 
		"""
		# Init some values
		self.list_of_personal_directories = list()
		self.list_of_sizes = list()
		self.total_size=0
	
	
		gtk.gdk.threads_enter()
	
	
		#If $HOME directories is active:
		if (self.glade_import_step1.get_widget("cb_home_directories").get_active()):
			
			# Foreach "toggled" home in checkbox:
			for usernode in self.liststore:
				if usernode[0] :
					aux_home = usernode[2]
					aux_cmd = "du -s "+ aux_home + " 2> /dev/null" 
					aux_size =  commands.getoutput((aux_cmd)).split('\t')[0]
					self.total_size = self.total_size + int(aux_size)
		

		else:
			
			# If $MAIL directories is active
			if(self.glade_import_step1.get_widget("cb_mail").get_active()):

				for usernode in self.liststore:
					if usernode[0] :
						# Path to Mail directory
						aux_mail_path = usernode[2]+os.sep+MOZILLA_DIRECTORY+os.sep+MAIL_DIRECTORY+os.sep
						
						if os.path.exists(aux_mail_path):
							aux_cmd = 'du -s '+aux_mail_path + ' 2 >/dev/null'
							aux_size =  commands.getoutput(aux_cmd).split('\t')[0]
							self.total_size = self.total_size + int(aux_size)

			# FIREFOX 
			if(self.glade_import_step1.get_widget("cb_bookmarks").get_active()):
				for usernode in self.liststore:
					if usernode[0] :
						# Path to Firefox directory
						aux_firefox_path = usernode[2]+os.sep+MOZILLA_DIRECTORY+os.sep+FIREFOX_DIRECTORY+os.sep
						
						if os.path.exists(aux_firefox_path):
							aux_cmd = 'du -s ' + aux_firefox_path + ' 2>/dev/null' 
							aux_size =  commands.getoutput((aux_cmd)).split('\t')[0]
							self.total_size = self.total_size + int(aux_size)
							
			# DESKTOP DIRECTORY			
			if(self.glade_import_step1.get_widget("cb_desktop_directories").get_active()):
				for usernode in self.liststore:
					if usernode[0] :
						
						# Path to Desktop directory
						aux_desktop_directory = usernode[2]+os.sep+DESKTOP_DIRECTORY+os.sep
						
						if os.path.exists(aux_desktop_directory):
							aux_cmd = 'du -s '+aux_desktop_directory+' 2>/dev/null'
							aux_size =  commands.getoutput((aux_cmd)).split('\t')[0]
							self.total_size = self.total_size + int(aux_size)
	
		# Custom directories
		for custom_dir in self.customlist:
			if os.path.exists(custom_dir[0]):
				aux_cmd = 'du -s '+custom_dir[0]+ ' 2>/dev/null'
				aux_size =  commands.getoutput(aux_cmd).split('\t')[0]
				self.total_size = self.total_size + int(aux_size)

		self.glade_import_step1.get_widget("label_size").set_text(self.bytes_to_human_readable_sizes(self.total_size))
		
		gtk.gdk.threads_leave()

	def bytes_to_human_readable_sizes(self,quantity):
		result="0 MB"
	
		megas=quantity/1024
		gigas=megas/1024
		teras=gigas/1024
	
		if (teras >0):
			teras = float(gigas/1024.0)
			result= "%.2f TB"%teras
		else :
			if (gigas > 0): 
				gigas = float(megas/1024.0)
				result="%.2f GB"%gigas
			else :
				if(megas > 0):
					megas = float(quantity/1024.0)
					result ="%.2f MB" %megas
	
		return " "+(result)
	
	def general_substitution_info_files(self,path,old,new):
		files = glob.glob(path)
		for line in fileinput.input(files,inplace=1):
			lineno = 0
			lineno = string.find(line, old)
			if lineno >0:
				line =line.replace(old, new)
			print line


if __name__ == "__main__":
	
	for arg in sys.argv: 
		print arg
		if arg == "--debug" :
			DEBUG_ACTIVE=True
		if arg == "--no-progress":
			DEBUG_PROGRESS=False
		if arg == "--help":
			print "USAGE: lliurex-vault [ --debug| --no-progress | --help]"
			sys.exit(0)
	try:
		a = Transmigracion()
		gtk.main()
	except KeyboardInterrupt:
		pass
